/*
	$Id: LoginException.java 5822 2011-10-24 11:44:02Z nicklas $

	Copyright (C) 2005 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	Exceptions of this type are thrown when the BASE server uses an
	external authentication plug-in and it is not clear if the
	login or password is causing the failure.

	@author Nicklas
	@since 3.0
*/
public class LoginException
	extends BaseException
{

	private static final long serialVersionUID = 5297093253941244696L;

	/**
		Create a new <code>LoginException</code> object with 
		the specified <code>message</code>

		@param message The message to throw with the exception
	*/
	public LoginException(String message)
	{
		super(message);
	}

	/**
		Create a new <code>LoginException</code> object with 
		the specified <code>message</code>
	
		@param message The message to throw with the exception
		@param cause The cause of the exception
	*/
	public LoginException(String message, Throwable cause)
	{
		super(message, cause);
	}
	
	
}


