/*
	$Id: OwnableUtil.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Samuel Andersson, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

import net.sf.basedb.core.data.OwnableData;

/**
	Utility methods that will make it easier to implement
	the {@link Ownable} interface, including data validation.
	
	@author Nicklas
	@version 2.0
	@see Ownable
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (Mon, 06 Apr 2009) $
*/
public class OwnableUtil
{

	/**
		Set the owner of a {@link OwnableData} object.
	 	@param ownableData Data object to set owner on. 
	 	@param owner User to be set as an owner.
		@throws InvalidDataException If the owner is null
	*/
	public static void setOwner(OwnableData ownableData, User owner)
		throws InvalidDataException
	{
		if (owner == null) throw new InvalidUseOfNullException("owner");
		ownableData.setOwner(owner.getData());
	}
	
}
