/*
	$Id: OwnedData.java 5818 2011-10-21 11:15:41Z nicklas $

	Copyright (C) 2005, 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	This class extends the {@link BasicData} class and implements the
	{@link OwnableData} interface. Ie. by extending this class a data item 
	gets an owner.

	@author Nicklas
	@version 2.0
	@see net.sf.basedb.core.OwnedItem
	@see <a href="../../../../../../html/developer/api/data_api.authentication.html">Developer documentation: User authentication</a>
	@see <a href="../../../../../../html/developer/api/data_api.basic.html">Developer documentation: Basic classes and interfaces</a>
*/
public abstract class OwnedData
	extends BasicData
	implements OwnableData
{

	public OwnedData()
	{}
	
	/*
		From the OwnableData interface
		-------------------------------------------
	*/
	private UserData owner;
	public UserData getOwner()
	{
		return owner;
	}
	public void setOwner(UserData owner)
	{
		this.owner = owner;
	}
	// -------------------------------------------

}
