/**
	$Id: PathSetter.java 5482 2010-11-10 11:16:51Z nicklas $

	Copyright (C) Authors contributing to this file.

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.extensions.xml;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
	Indicates that a factory setter method which takes a string as 
	it's input will have the value scanned by a {@link PathConverter}
	before the setter method is invoked.
	
	@author nicklas
	@version 2.7
	@see VariableSetter
	@see PathConverter
	@base.modified $Date: 2010-11-10 12:16:51 +0100 (Wed, 10 Nov 2010) $
*/
@Documented
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface PathSetter 
{
	/**
		The type of path that should be generated. The default is
		to generate absolute paths.
		@since 2.17
	*/
	public PathType pathType() default PathType.ABSOLUTE;
}
