/**
	$Id: IdentityUnitConverter.java 4544 2008-09-25 07:01:30Z nicklas $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.units;

/**
	A unit "converter" that doesn't modify the values.
	
	@author Nicklas
	@version 2.9
	@base.modified $Date: 2008-09-25 09:01:30 +0200 (Thu, 25 Sep 2008) $
*/
public class IdentityUnitConverter
	implements UnitConverter
{
	
	/**
		Create a new unit converter.
	*/
	public IdentityUnitConverter()
	{}
	
	/**
		From the UnitConverter interface
		--------------------------------
	*/
	/**
		@return The 'specific' value unmodified
	*/
	public double convertToReferenceUnit(double specific)
	{
		return specific;
	}
	/**
		@return The 'ref' value unmodified
	*/
	public double convertToSpecificUnit(double ref)
	{
		return ref;
	}
	// -----------------------------------
	
}
