<%-- $Id:manual_scan.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.plugin.About"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
 	import="net.sf.basedb.util.extensions.manager.ExtensionsManager"
 	import="net.sf.basedb.util.extensions.manager.ExtensionsFile"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	ExtensionsControl ec = ExtensionsControl.get(dc);
	ec.checkPermission(Permission.WRITE);
	ec.scanForChanges();
	List<ExtensionsFile> xtFiles = ec.getFiles();
	%>
	<base:page type="popup" title="Extensions and plug-ins installation wizard">
	<base:head scripts="table.js" styles="table.css">
		<script language="JavaScript">
		
		// Submit the form
		function startManualScan()
		{
			var frm = document.forms['scan'];
			frm.cmd.value = 'DoManualScan';
			frm.submit();
		}
		
		function installOnClick(name)
		{
			var frm = document.forms['scan'];
			if (frm[name+'.install'].checked)
			{
				if (frm[name+'.uninstall']) frm[name+'.uninstall'].checked = false;
			}
		}

		function uninstallOnClick(name)
		{
			var frm = document.forms['scan'];
			if (frm[name+'.uninstall'].checked)
			{
				if (frm[name+'.install']) frm[name+'.install'].checked = false;
			}
		}
		</script>
	</base:head>
	<base:body>
	<h1>Extensions and plug-ins installation wizard <base:help helpid="extensions.install-wizard" /></h1>
	
	
	<div class="content">
	<tbl:table id="scan" subclass="fulltable" action="index.jsp" >
		<tbl:columndef id="file" title="File" />
		<tbl:columndef id="status" title="Status" />
		<tbl:columndef id="install" title="Install" />
		<tbl:columndef id="uninstall" title="Uninstall" />
		<tbl:columndef id="about" title="About" />
	
		<tbl:data style="top: 0px; margin-top: 0px;">
			<tbl:headers>
				<tbl:headerrow>
					<tbl:columnheaders />
				</tbl:headerrow>
			</tbl:headers>
			<tbl:rows>
			<%
			for (ExtensionsFile xtFile : xtFiles)
			{
				if (xtFile.getFile() == null) continue; // We skip internal extensions/plug-ins files
				
				About about = xtFile.getAbout();	
				Throwable error = null;
				String name = xtFile.getName();
				String status = "";
				String icon = "";
				boolean allowInstall = false;
				boolean allowUninstall = false;
				boolean checkInstall = false;
				boolean checkUninstall = false;
				if (!xtFile.exists())
				{
					status = "Deleted";
					allowUninstall = true;
					checkUninstall = true;
				}
				else if (!xtFile.isValid())
				{
					status = "Invalid";
					error = xtFile.getValidationError();
					if (xtFile.isInstalled())
					{
						allowUninstall = true;
						checkUninstall = true;
					}
				}
				else if (xtFile.isNew())
				{
					status = "New";
					allowInstall = true;
					checkInstall = true;
				}
				else if (xtFile.checkModified())
				{
					status = "Modified";
					allowInstall = true;
					allowUninstall = true;
					checkInstall = true;
				}
				else
				{
					status = "Already installed";
					allowInstall = true;
					allowUninstall = true;
				}
				%>
				<tbl:row>
					<tbl:cell column="file"><%=name%></tbl:cell>
					<tbl:cell column="status"><%=status%></tbl:cell>
					<tbl:cell column="install"  style="text-align: center;">
						<%
						if (allowInstall)
						{
							%>
							<input type="checkbox" name="<%=name%>.install" value="1" <%=checkInstall ? "checked" : "" %>
								onclick="installOnClick('<%=name%>')">
							<%
						}
						%>
					</tbl:cell>
					<tbl:cell column="uninstall" style="text-align: center;">
						<%
						if (allowUninstall)
						{
							%>
							<input type="checkbox" name="<%=name%>.uninstall" value="1" <%=checkUninstall ? "checked" : "" %>
								onclick="uninstallOnClick('<%=name%>')">
							<%
						}
						%>
					</tbl:cell>
					<tbl:cell column="about">
						<%
						if (about != null)
						{
							%>
							<b><%=about.getName()%></b> <%=about.getVersion() == null ? "" : "(v" + about.getVersion() + ")"%><br>
							<%=HTML.encodeTags(about.getDescription())%><br>
							<%=HTML.niceFormat(about.getUrl())%>
							<%
						}
						if (error != null)
						{
							%>
							<div class="messagecontainer error">
							<%=error.getClass().getSimpleName()%>: <%=HTML.encodeTags(error.getMessage())%>
							</div>
							<%
						}
						%>
					</tbl:cell>
					
				</tbl:row>
				<%
			}
			%>
			</tbl:rows>
		</tbl:data>
	</tbl:table>
	</div>

	<base:buttongroup subclass="dialogbuttons">
		<base:button onclick="startManualScan();" title="Next" />
		<base:button onclick="window.close();" title="Cancel" />
	</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
