<%-- $Id:edit_variant.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.PlatformFileType"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final int platformId = Values.getInt(request.getParameter("platform_id"));
final Item itemType = Item.PLATFORMVARIANT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Platform platform = null;
	PlatformVariant variant = null;
	boolean isFileOnly = false;
	ItemQuery<PlatformFileType> fileTypeQuery = null;
	
	if (itemId == 0)
	{
		title = "Create platform variant";
		platform = Platform.getById(dc, platformId);
		isFileOnly = Values.getBoolean(cc.getPropertyValue("fileOnly"), platform.isFileOnly());
		cc.removeObject("item");
		platform.checkPermission(Permission.WRITE);
	}
	else
	{
		variant = PlatformVariant.getById(dc, itemId);
		platform = variant.getPlatform();
		isFileOnly = variant.isFileOnly();
		cc.setObject("item", variant);
		title = "Edit platform variant -- " + HTML.encodeTags(variant.getName());
		variant.checkPermission(Permission.WRITE);
		fileTypeQuery = platform.getFileTypes(variant, true);
		fileTypeQuery.include(Include.ALL);
		fileTypeQuery.order(Orders.asc(Hql.property("dataFileType.name")));
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	final String unchangeableClazz = "class=\"text required unchangeable\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), variant);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Variant" tab
		function validateVariant()
		{
			var frm = document.forms['variant'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.externalId)
			{
				var fileOnly = Forms.getCheckedRadio(frm.fileOnly).value == '1';
				if (Main.trimString(frm.externalId.value) == '')
				{
					alert("You must enter an external ID");
					frm.externalId.focus();
					return false;
				}
				else if (fileOnly)
				{
					if (!Numbers.isInteger(frm.channels.value))
					{
						alert("You must enter the number of channels");
						frm.channels.focus();
						return false;
					}
					if (parseInt(frm.channels.value) <= 0)
					{
						alert("The number of channels must be > 0");
						frm.channels.focus();
						return false;
					}
				}
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['variant'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.modifiedFileTypes.value = Link.exportModified(frm, 'F', true).join(',');
				frm.removedFileTypes.value = Link.getActionIds(-1, 'F').join(',');
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (variant == null)
			{
				%>
				var frm = document.forms['variant'];
				frm.name.focus();
				frm.name.select();
				fileOnlyOnClick();
				<%
			}
			%>
			initFileTypes();
		}
		function fileOnlyOnClick()
		{
			var frm = document.forms['variant'];
			var fileOnly = Forms.getCheckedRadio(frm.fileOnly).value == '1';
			frm.rawdatatype.disabled = fileOnly;
			frm.channels.disabled = !fileOnly;
			Main.addOrRemoveClass(frm.rawdatatype, 'required', !frm.rawdatatype.disabled);
			Main.addOrRemoveClass(frm.channels, 'required', !frm.channels.disabled);
		}
		function initFileTypes()
		{
			var fileTypes = document.forms['variant'].fileTypes;
			<%
			if (fileTypeQuery != null)
			{
				ItemResultList<PlatformFileType> fileTypes = fileTypeQuery.list(dc);
				for (PlatformFileType ft : fileTypes)
				{
					DataFileType dft = ft.getDataFileType();
					boolean required = ft.isRequired();
					boolean multiple = ft.getAllowMultiple();
					int value = 0;
					if (required) value += 1;
					if (multiple) value += 2;
					%>
					Link.addNewItem(fileTypes, new Item('F', <%=dft.getId()%>, '<%=HTML.javaScriptEncode(dft.getName())%> <%=required ? "[×]" : "[-]"%>', <%=value%>));
					<%
				}
			}
			%>
		}
		function addFileTypesOnClick()
		{
			var frm = document.forms['variant'];
			Main.openPopup('../../datafiletypes/index.jsp?ID=<%=ID%>&mode=selectmultiple&callback=addFileTypeCallback', 'AddFileTypes', 1050, 700);
		}
		function addFileTypeCallback(fileTypeId, name)
		{
			var item = Link.getItem('F', fileTypeId);
			var frm = document.forms['variant'];
			var required = frm.required.checked;
			var multiple = frm.multiple.checked;
			var newValue = 0;
			if (required) newValue += 1;
			if (multiple) newValue += 2;
			if (!item) item = new Item('F', fileTypeId, name+(required ? '[×]' : '[-]'), newValue, '');
			Link.addItem(frm.fileTypes, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['variant'].fileTypes);
		}
		function fileTypesOnChange()
		{
			var frm = document.forms['variant'];
			var item = frm.fileTypes[frm.fileTypes.selectedIndex].item;
			if (item && item.id)
			{
				frm.required.checked = (item.value & 1) > 0;
				frm.multiple.checked = (item.value & 2) > 0;
			}
			else
			{
				frm.required.checked = false;
				frm.multiple.checked = false;
			}
		}
		function requiredOnClick()
		{
			var frm = document.forms['variant'];
			var required = frm.required.checked;
			var multiple = frm.multiple.checked;
			var newValue = 0;
			if (required) newValue += 1;
			if (multiple) newValue += 2;
			for (var i = 0; i < frm.fileTypes.length; i++)	// >
			{
				var option = frm.fileTypes[i];
				if (option.selected && option.item.id)
				{
					option.item.value = newValue;
					var text = option.text.replace(/\[.*\]/, '['+(required ? '×' : '-') +']');
					option.text = text; 
				}
			}
		}
		function multipleOnClick()
		{
			requiredOnClick();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="variant" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="platform_id" value="<%=platformId%>">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && variant != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Variant" validate="validateVariant()" helpid="platformvariant.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(variant == null ? 
							Values.getString(cc.getPropertyValue("name"), "New " + platform.getName() + " variant") : 
							variant.getName())%>" 
					maxlength="<%=PlatformVariant.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<%
			if (variant == null)
			{
				// For new platforms only
				RawDataType currentRawDataType = 
					RawDataTypes.getRawDataType(cc.getPropertyValue("rawDataType"));
				if (currentRawDataType == null)
				{
					currentRawDataType = platform.getRawDataType();
				}
				%>
				<tr>
					<th>External ID</th>
					<td><input <%=unchangeableClazz%> type="text" name="externalId" 
						value="<%=HTML.encodeTags(Values.getString(cc.getPropertyValue("externalId"), platform.getExternalId() + ".new"))%>" 
						maxlength="<%=PlatformVariant.MAX_EXTERNAL_ID_LENGTH%>"></td>
					<td></td>
				</tr>
				<tr>
					<th>File-only</th>
					<td>
						<input <%=unchangeableClazz%> type="radio" name="fileOnly" id="fileOnlyNo" value="0" 
							<%=!isFileOnly ? "checked" : ""%> onclick="fileOnlyOnClick()"><label for="fileOnlyNo">no</label>
						<input <%=unchangeableClazz%> type="radio" name="fileOnly" id="fileOnlyYes" value="1" 
							<%=isFileOnly ? "checked" : ""%> onclick="fileOnlyOnClick()"><label for="fileOnlyYes">yes</label>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Raw data type</th>
					<td>
						<select name="rawdatatype" <%=unchangeableClazz%>>
						<option value="">- any -
						<%
						for (RawDataType rdt : RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
						{
							if (rdt.isStoredInDb())
							{
								String selected = rdt.equals(currentRawDataType) ? "selected" : "";
								%>
								<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
								<%
							}
						}
						%>
						</select>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Channels</th>
					<td><input <%=unchangeableClazz%> type="text" name="channels" 
						value="<%=Values.getInt(cc.getPropertyValue("channels"), currentRawDataType == null ? 1 : currentRawDataType.getChannels())%>" 
						maxlength="10" style="width: 15em;"
						onkeypress="return Numbers.integerOnly(event)"></td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(variant == null ? cc.getPropertyValue("description") : variant.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'variant', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		<t:tab id="fileTypes" title="Data file types"
			tooltip="Associate this platform variant with date file types"
			helpid="platformvariant.edit.filetypes"
			>
			<table class="fullform input100 smaller">
			<tr class="dynamic">
				<th>Data file types</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
							<td>
								<select name="fileTypes" size="15" multiple onchange="fileTypesOnChange()">
								</select>
								<input type="hidden" name="modifiedFileTypes" value="">
								<input type="hidden" name="removedFileTypes" value="">
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										subclass="leftaligned"
										style="width: 14em;"
										onclick="addFileTypesOnClick()" 
										title="Add&nbsp;data file types&hellip;" 
										tooltip="Add more data file types to this platform"
									/>
									<base:button 
										subclass="leftaligned"
										style="width: 14em;"
										onclick="removeOnClick()" 
										title="Remove" 
										tooltip="Remove the selected data file types"
									/>
								</base:buttongroup>
								<input type="checkbox" id="required" name="required" value="1" onchange="requiredOnClick()">
									<label for="required">Required</label><br>
								<input type="checkbox" id="multiple" name="multiple" value="1" onchange="multipleOnClick()">
									<label for="multiple">Allow multiple files</label>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>
		</t:tab>		
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (variant == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
