<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.InvalidDataException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
try
{
	if ("WellInfo".equals(cmd))
	{
		dc = sc.newDbControl();
		boolean encodeStrings = Values.getBoolean(request.getParameter("encodeStrings"));
		BioWell well = BioWell.getById(dc, itemId);
		boolean isEmpty = well.isEmpty();
		boolean hasBeenUsed = well.hasBeenUsed();
		
		json.put("id", well.getId());
		json.put("isEmpty", isEmpty);
		
		if (!isEmpty || hasBeenUsed)
		{
			JSONObject jsonBioMaterial = new JSONObject();
			try
			{
				MeasuredBioMaterial bioMaterial = isEmpty ? well.getOriginalBioMaterial() : well.getBioMaterial();
				jsonBioMaterial.put("id", bioMaterial.getId());
				jsonBioMaterial.put("type", bioMaterial.getType().name());
				jsonBioMaterial.put("name", encodeStrings ? HTML.encodeTags(bioMaterial.getName()) : bioMaterial.getName());
				jsonBioMaterial.put("description", encodeStrings ? HTML.niceFormat(bioMaterial.getDescription()) : bioMaterial.getDescription());
				jsonBioMaterial.put("editable", bioMaterial.hasPermission(Permission.WRITE));
				ItemSubtype subtype = bioMaterial.getItemSubtype();
				if (subtype != null)
				{
					JSONObject jsonSubtype = new JSONObject();
					jsonSubtype.put("id", subtype.getId());
					jsonSubtype.put("name", HTML.encodeTags(subtype.getName()));
					jsonBioMaterial.put("subtype", jsonSubtype);
				}
			}
			catch (PermissionDeniedException ex)
			{
				jsonBioMaterial.put("denied", true);
			}
			json.put("bioMaterial", jsonBioMaterial);
		}
		dc.close();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>