<%-- $Id: expression_builder.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@page import="net.sf.basedb.core.StringUtil"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.VirtualDb"
	import="net.sf.basedb.core.ReporterCloneTemplate"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.jep.Jep"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
	String title = request.getParameter("title");
	String form = request.getParameter("form");
	String textarea = request.getParameter("textarea");
	String callback = request.getParameter("callback");
	Formula.Type formulaType = Formula.Type.valueOf(request.getParameter("formulatype"));
	RawDataType rawDataType = RawDataTypes.getRawDataType(request.getParameter("rawdatatype"));
	int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"), -1);
	boolean restrictions = Values.getBoolean(request.getParameter("restrictions"));
	int channels = Values.getInt(request.getParameter("channels"));
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
	
	DbControl dc = sc.newDbControl();
	try
	{
		BioAssaySet bas = bioAssaySetId == -1 ? null : BioAssaySet.getById(dc, bioAssaySetId);
		VirtualDb vdb = bas != null ? bas.getExperiment().getVirtualDb() : null;
		ReporterCloneTemplate template = vdb != null && vdb.hasClonedReporters() ? vdb.getReporterCloneTemplate() : null;
				
		IntensityTransform transform = bas == null ? null : bas.getIntensityTransform();
		int maxRawMappings = bas == null ? 1 : bas.getMaxRawMappingsForSpot();

		List<TableColumn> spotProperties = new LinkedList<TableColumn>();
		DynamicUtil.addSpotColumns(spotProperties, dc, channels, transform);
		List<TableColumn> rawProperties = new LinkedList<TableColumn>();
		if (rawDataType != null)
		{
			DynamicUtil.addFormulaColumns(spotProperties, dc, rawDataType, 
				Formula.Type.COLUMN_EXPRESSION, transform, "", "", maxRawMappings == 1);
			if (bas != null) DynamicUtil.addExtraColumns(spotProperties, dc, bas, "", "", "[Xtra] ");
			if (maxRawMappings == 1) DynamicUtil.addRawDataColumns(rawProperties, dc, rawDataType, "", "", "");
		}
		List<TableColumn> reporterProperties = new LinkedList<TableColumn>();
		DynamicUtil.addReporterColumns(reporterProperties, dc, template, "", "", "");
		
		ItemQuery<ReporterList> reporterListQuery = ReporterList.getQuery();
		reporterListQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
		reporterListQuery.order(Orders.asc(Hql.property("name")));
		List<ReporterList> reporterLists = reporterListQuery.list(dc);
		
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="table.js" styles="toolbar.css">
		<script language="JavaScript">
		function getText()
		{
			document.forms['expression'].expression.value = window.opener.document.forms['<%=form%>'].elements['<%=textarea%>'].value;
		}
		function setExpressionAndClose()
		{
			var value = document.forms['expression'].expression.value;
			<%
			if (callback != null)
			{
				StringBuilder sb = new StringBuilder();
				sb.append("window.opener.");
				sb.append(callback).append("(");
				if (form != null) sb.append("'").append(form).append("',");
				if (textarea != null) sb.append("'").append(textarea).append("',");
				sb.append("value)");
				%>
				<%=sb.toString()%>
				<%
			}
			else
			{
				%>
				var textElement = window.opener.document.forms['<%=form%>'].elements['<%=textarea%>'];
				if (textElement.type == 'text') value = value.replace(/\n/g, '');
				textElement.value = value;
				<%
			}
			%>
			window.close();
		}
		function insertSelected(list, prefix, suffix)
		{
			var value = list[list.selectedIndex].value;
			if (value != '')
			{
				if (prefix) value = prefix + value;
				if (!suffix) suffix = ''; 
				encloseSelection(value, suffix);
			}
			list.selectedIndex = 0;
		}
		function insertReporterListFunction()
		{
			var frm = document.forms['expression'];
			var listFunction = frm.listFunction[frm.listFunction.selectedIndex].value;
			var listId = frm.reporterList[frm.reporterList.selectedIndex].value;
			encloseSelection(listFunction+'(' + listId + ')', '');
			frm.reporterList.selectedIndex = 0;
		}
	
		/*
			Enclose the selected text with prefix and suffix. Code taken
			from Trac: http://projects.edgewall.com/trac/
		*/
		function encloseSelection(prefix, suffix) 
		{
			var frm = document.forms['expression'];
			var textarea = frm.expression;
			textarea.focus();
		    var start, end, sel, scrollPos, subst;
		    if (typeof(document["selection"]) != "undefined") 
		    {
		      sel = document.selection.createRange().text;
		    } 
		    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
		    {
		      start = textarea.selectionStart;
		      end = textarea.selectionEnd;
		      scrollPos = textarea.scrollTop;
		      sel = textarea.value.substring(start, end);
		    }
		    if (sel.match(/ $/)) 
		    { 
		    	// exclude ending space char, if any
		      	sel = sel.substring(0, sel.length - 1);
		      	suffix = suffix + " ";
		    }
		    subst = prefix + sel + suffix;
		    if (typeof(document["selection"]) != "undefined") 
		    {
		      var range = document.selection.createRange().text = subst;
		      textarea.caretPos -= suffix.length;
		    } 
		    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
		    {
		      textarea.value = textarea.value.substring(0, start) + subst +
		                       textarea.value.substring(end);
		      if (sel) 
		      {
		        textarea.setSelectionRange(start + subst.length, start + subst.length);
		      } 
		      else 
		      {
		        textarea.setSelectionRange(start + prefix.length, start + prefix.length);
		      }
		      textarea.scrollTop = scrollPos;
		    }
		  }
		
		var properties = new Array();
		<%
		for (TableColumn tc : rawProperties)
		{
			%>
			properties['raw.<%=tc.getProperty()%>'] = 1;
			<%
		}
		for (TableColumn tc : reporterProperties)
		{
			%>
			properties['reporter.<%=tc.getProperty()%>'] = 1;
			<%
		}
		%>
			
		function validateOnClick()
		{
			var frm = document.forms['expression'];
			if (frm.expression.value != '')
			{
				var expression = frm.expression.value.replace('if(', 'jepIf(');
				try
				{
					var result = eval(expression);
					alert('The expressions seems to be ok.\nNote! This feature is experimental and may not be 100% correct.');
				}
				catch (er)
				{
					alert(er + '\nNote! This feature is experimental and may not be 100% correct.');
				}
			}
		}
		
		function raw(property)
		{
			<%
			if (maxRawMappings != 1)
			{
				%>
				throw 'Cannot use function raw() for bioassayset that has multiple mappings to raw data';
				<%
			}
			%>
			var rdt = '<%=rawDataType == null ? "" : rawDataType.getId()%>';
			if (!property) throw 'Property must be specified for function raw()';
			if (rdt == '') throw 'Cannot use function raw(). No raw data type selected';
			if (!properties['raw.'+property]) throw 'Property '+property+' not found for raw data type ' + rdt;
			return Math.random() * 100;
		}
		
		function mean(property)
		{
			var rdt = '<%=rawDataType == null ? "" : rawDataType.getId()%>';
			if (!property) throw 'Property must be specified for function mean()';
			if (rdt == '') throw 'Cannot use function mean(). No raw data type selected';
			if (!properties['property.'+property]) throw 'Property '+property+' not found for raw data type ' + rdt;
			return Math.random() * 100;
		}
	
		function ch(channel)
		{
			checkChannel('ch()', channel);
			return channel;
		}
		function rawCh(channel)
		{
			checkChannel('rawCh()', channel);
			return channel;
		}
		function checkChannel(name, channel)
		{
			var type = '<%=formulaType.name()%>';
			if (type == '<%=Formula.Type.INTENSITY_EXPRESSION.name()%>')
			{
				// Channel function not available
				throw 'Function ' + name + ' is not available for ' + type;
			}
			var channels = <%=channels%>;
			if (!channel || channel <= 0 || channel > channels) 
			{
				throw 'Invalid channel: ' + channel + '; must be between 1 and '+ channels;
			}
		}


		
		function pos()
		{
			return Math.random() * 100;
		}
		function rep(property)
		{
			if (!property) throw 'Property must be specified for function rep()';
			if (!properties['reporter.'+property]) throw 'Property '+property+' not found for reporter';
			return Math.random() * 100;
		}
		
		function xtra(arg)
		{
			if (!arg) throw 'One argument is required for function xtra()';
			return Math.random() * 100;
		}
		
		function log(value)
		{
			return Math.log(value);
		}
		function log2(value)
		{
			return Math.log(value);
		}
		function ln(value)
		{
			return Math.log(value);
		}
		function sqrt(value)
		{
			return Math.sqrt(value);
		}
		function abs(value)
		{
			return Math.abs(value);
		}
		function exp(value)
		{
			return Math.exp(value);
		}
		function score(reporterListId)
		{
			return Math.random() * 100;
		}
		function jepIf(condition, ifTrue, ifFalse)
		{
			if (condition == undefined || ifTrue == undefined || ifFalse == undefined)
			{
				throw 'if() needs 3 arguments';
			}
			return condition ? ifTrue : ifFalse;
		}
		</script>
	</base:head>
	<base:body onload="getText()">
		<h1>Expression builder <base:help helpid="expressionbuilder" /></h1>
	
		<form name="expression" onsubmit="return false;">
		<div class="content">
			<table style="width: 100%; height: 100%;"><tr style="height: 10%;"><td>
				<tbl:toolbar>
					<tbl:label
						style="width: 100px;"
						title="Operators:"
					/>
					<tbl:button 
						title="AND"
						tooltip="BOOLEAN AND: expr1 &amp;&amp; expr2"
						onclick="encloseSelection(' &amp;&amp; ', '')"
					/>
					<tbl:button 
						title="OR"
						tooltip="BOOLEAN OR: expr1 || expr2"
						onclick="encloseSelection(' || ', '')"
					/>
					<tbl:button 
						title="NOT"
						tooltip="BOOLEAN NOT: !expr1"
						onclick="encloseSelection('!', '')"
					/>
					<tbl:button 
						title="=="
						tooltip="EQUAL: expr1 == expr2"
						onclick="encloseSelection(' == ', '')"
					/>
					<tbl:button 
						title="!="
						tooltip="INEQUAL: expr1 != expr2"
						onclick="encloseSelection(' != ', '')"
					/>
					<tbl:button 
						title="&lt;"
						tooltip="LESS: expr1 &lt; expr2"
						onclick="encloseSelection(' &lt; ', '')"
					/>
					<tbl:button 
						title="&lt;="
						tooltip="LESS OR EQUAL: expr1 &lt;= expr2"
						onclick="encloseSelection(' &lt;= ', '')"
					/>
					<tbl:button 
						title="&gt;="
						tooltip="MORE OR EQUAL: expr1 &gt;= expr2"
						onclick="encloseSelection(' &gt;= ', '')"
						visible="<%=restrictions%>"
					/>
					<tbl:button 
						title="&gt;"
						tooltip="MORE: expr1 &gt; expr2"
						onclick="encloseSelection(' &gt; ', '')"
					/>
					<tbl:button 
						title="+"
						tooltip="ADD: expr1 + expr2"
						onclick="encloseSelection(' + ', '')"
					/>
					<tbl:button 
						title="-"
						tooltip="SUBTRACT: expr1 - expr2"
						onclick="encloseSelection(' - ', '')"
					/>
					<tbl:button 
						title="*"
						tooltip="MULTIPLY: expr1 * expr2"
						onclick="encloseSelection(' * ', '')"
					/>
					<tbl:button 
						title="/"
						tooltip="DIVIDE: expr1 / expr2"
						onclick="encloseSelection(' / ', '')"
					/>
					<tbl:button 
						title="( )"
						tooltip="PARENTHESIS: (expr1)"
						onclick="encloseSelection('(', ')')"
					/>
				</tbl:toolbar>
				<tbl:toolbar
					style="border-top: 0px;"
					>
					<tbl:label
						title="Functions:"
						style="width: 100px;"
					/>
					<%
					Enumeration<String, String> functions = Jep.getFunctions();
					for (int i = 0; i < functions.size(); ++i)
					{
						String function = functions.getKey(i);
						%>
						<tbl:button 
							title="<%=function%>"
							tooltip="<%=functions.getValue(i)%>"
							onclick="<%="encloseSelection('" + function +"(', ')')"%>"
						/>
						<%
					}
					%>
					<tbl:label
						title="Constants:"
						style="width: 100px;"
					/>
					<tbl:button 
						title="null"
						tooltip="The null (unknown) value"
						onclick="<%="encloseSelection('', 'null')"%>"
					/>
					<tbl:button 
						title="pi"
						tooltip="<%="The pi value: " + Math.PI %>"
						onclick="<%="encloseSelection('', '"+Math.PI+"')"%>"
					/>
					<tbl:button 
						title="e"
						tooltip="<%="The base of the natural logarithm: " + Math.E%>"
						onclick="<%="encloseSelection('', '"+Math.E+"')"%>"
					/>
				</tbl:toolbar>
				<tbl:toolbar
					style="border-top: 0px;">
					<td class="label">Spot:
						<select name="spot" onchange="insertSelected(this)" style="width: 12em;">
						<option value="">- select -
						<%
						for (TableColumn tc : spotProperties)
						{
							if (tc.getJepExpression() != null)
							{
								%>
								<option value="<%=tc.getJepExpression()%>" 
									title="<%=HTML.encodeTags(tc.getDescription())%>"><%=HTML.encodeTags(tc.getTitle())%>
								<%
							}
						}
						%>
						</select>		
					</td>
					<%
					if (rawDataType != null && rawDataType.isStoredInDb() && rawProperties.size() > 0)
					{
						%>
						<td class="label">Raw data:
							<select name="rawdata" onchange="insertSelected(this)" style="width: 12em;">
							<option value="">- select -
							<%
							for (TableColumn tc : rawProperties)
							{
								%>
								<option value="<%=tc.getJepExpression()%>" 
									title="<%=HTML.encodeTags(tc.getDescription())%>"><%=HTML.encodeTags(tc.getTitle())%>
								<%
							}
							%>
							</select>
						</td>
						<%
					}
					%>
					
					<td class="label">Reporter:
						<select name="reporter" onchange="insertSelected(this)" style="width: 12em;">
						<option value="">- select -
							<%
							for (TableColumn tc : reporterProperties)
							{
								%>
								<option value="<%=tc.getJepExpression()%>" 
									title="<%=HTML.encodeTags(tc.getDescription())%>"><%=HTML.encodeTags(tc.getTitle())%>
								<%
							}
							%>
						</select>
				</tbl:toolbar>
				<tbl:toolbar
					style="border-top: 0px;"
					visible="<%=reporterLists.size() > 0%>">
					<td class="label">
						Reporter lists: 
						
						<select name="listFunction"	>
						<option value="score">score
						<%
						if (restrictions)
						{
							%>
							<option value="inList">in
							<option value="notInList">not in
							<%
						}
						%>
						</select>
						
						<select name="reporterList" onchange="insertReporterListFunction()">
						<option value="">- select -
							<%
							for (ReporterList list : reporterLists)
							{
								%>
								<option value="<%=list.getId()%>" 
									title="<%=HTML.encodeTags(list.getDescription())%>"><%=HTML.encodeTags(list.getName())%>
								<%
							}
							%>
						</select>
					</td>
				</tbl:toolbar>
				</td>
				</tr>
				<tr style="height: 90%;"><td>
				<table class="fullcc input100"><tr><td>
				<textarea class="autohight" name="expression" rows="16"></textarea>
				</td></tr></table>
				</td></tr></table>

			</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button 
				onclick="validateOnClick()" title="Validate&hellip;" 
				image="validate_formula.png"
				tooltip="Validate the expression. EXPERIMENTAL!!" />
			<base:button onclick="setExpressionAndClose()" title="Ok" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
	}
finally
{
	if (dc != null) dc.close();
}
%>	
