<%-- $Id: info.jsp 6033 2012-03-29 09:20:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.AnyToAny"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.AnnotationFilter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.NestedIterator"
	import="net.sf.basedb.util.overview.GenericOverview"
	import="net.sf.basedb.util.overview.OverviewUtil"
	import="net.sf.basedb.util.overview.Node"
	import="net.sf.basedb.util.overview.ValidationOptions"
	import="net.sf.basedb.util.overview.Validator"
	import="net.sf.basedb.util.overview.Severity"
	import="net.sf.basedb.util.overview.Failure"
	import="net.sf.basedb.util.overview.Fix"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Iterator"
	import="java.util.Collection"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
private String getPath(DbControl dc, String ID, Node node)
{
	Node parent = node.getParent();
	if (parent == null) return "";
	String path = getPath(dc, ID, parent);
	if (parent.getNodeType() == Node.Type.FOLDER)
	{
		//path += "/" + HTML.encodeTags(parent.getTitle());
	}
	else
	{
		BasicItem item = parent.getItem();
		if (path.length() > 0)
		{
			path += " <b>›</b> ";
		}
		path += Base.getLink(ID, parent.getTitle(), item.getType(), item.getId(), item.hasPermission(Permission.WRITE));
		
		if (item instanceof Subtypable)
		{
			ItemSubtype subtype = ((Subtypable)parent.getItem(dc)).getItemSubtype();
			if (subtype != null)
			{
				path += " <span class=\"itemsubtype\">(" + Base.getLinkedName(ID, subtype, false, true) + ")</span>";
			}
		}
	}
	return path;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	final GenericOverview overview = OverviewUtil.getCurrentOverview(sc);
	final ItemContext cc = sc.getCurrentContext(overview.getRootItem().getType());
	final SnapshotManager snapshotManager = new SnapshotManager();
	final AnnotationTypeFilter annotationTypeFilter = new AnnotationTypeFilter();
	final AnnotationFilter annotationFilter = new AnnotationFilter();
	ValidationOptions options = overview.getValidationOptions();
	String nodeId = request.getParameter("nodeId");
	Boolean showFailures = Values.getBoolean(request.getParameter("show_failures"), false);
	Node node = overview.getNode(nodeId);
	if (node == null) node = overview.getRootNode();

	BasicItem item = node.getItem(dc);
	List<Failure> failures = overview.getFailures();
	if (failures == null) failures = new LinkedList<Failure>();
	%>
	<base:page title="" type="iframe">
	<base:head styles="table.css">
	<script language="JavaScript">
	function editItem(itemType, itemId, extraUrl)
	{
		Main.viewOrEditItem('<%=ID%>', itemType, itemId, true, extraUrl);
	}
	function editAnnotation(itemType, itemId, annotationTypeId)
	{
		var url = getRoot() + 'common/annotations/annotate.jsp?ID=<%=ID%>';
		url += '&item_type=' + itemType;
		url += '&item_id=' + itemId;
		url += '&annotationtype_id='+annotationTypeId;
		url += '&standalone=1';
		Main.openPopup(url, 'EditAnnotation', 750, 500);
	}
	function editInheritedAnnotation(itemType, itemId, annotationTypeId)
	{
		var url = getRoot() + 'common/annotations/inherit.jsp?ID=<%=ID%>';
		url += '&item_type='+itemType;
		url += '&item_id='+itemId;
		url += '&annotationtype_id='+annotationTypeId;
		url += '&standalone=1';
		Main.openPopup(url, 'EditAnnotation', 750, 500);
	}
	function editDataFile(itemType, itemId)
	{
		Main.viewOrEditItem('<%=ID%>', itemType, itemId, true, '&tab=datafiles');
	}
	
	</script>
	<style>
	.itemsubtype .link 
	{
		color: #777777;
	}
	</style>
	</base:head>

		<base:body>
			<div class="absolutefull" onmousemove="parent.DragDrop.drag(event)" onmouseup="parent.DragDrop.endDrag(event)">
			<div>
			<table class="fullform bottomborder outlined">
			<tr>
				<th>Path</th>
				<td><%=getPath(dc, ID, node)%></td>
			</tr>
			<%
			if (item instanceof FileSetMember)
			{
				FileSetMember member = null;
				boolean notFound = false;
				try
				{	
					member = FileSetMember.getById(dc, item.getId());
				}
				catch (ItemNotFoundException ex)
				{
					notFound = true;
				}
				File file = null;
				DataFileType dft = null;
				boolean deniedFile = false;
				boolean deniedFileType = false;
				if (member != null)
				{
					try
					{
						file = member.getFile();
					}
					catch (PermissionDeniedException ex)
					{
						deniedFile = true;
					}
					try
					{
						dft = member.getDataFileType();
					}
					catch (PermissionDeniedException ex)
					{
						deniedFileType = true;
					}
				}
				if (dft != null || file != null)
				{
					%>
					<tr>
						<th><%=dft == null ? "Data file" : HTML.encodeTags(dft.getName())%></th>
						<td>
							<%=Base.getLinkedFile(ID, file, deniedFile, true, true, "../../")%>
						</td>
					</tr>
					<%
				}
				else
				{
					%>
					<tr>
					<th><%=HTML.encodeTags(node.getTitle())%></th>
					<td>
						<%=notFound ? "<i>- not found -</i>" : "<i>- denied -</i>"%>
					</td>
					</tr>
					<%
				}
			}
			else if (item instanceof AnyToAny)
			{
				AnyToAny any = AnyToAny.getById(dc, item.getId());
				String linkTo = null;
				try
				{
					BasicItem to = any.getTo();
					String name = to instanceof Nameable ? ((Nameable)to).getName() : to.toString();
					linkTo = Base.getLink(ID, HTML.encodeTags(name), 
							to.getType(), to.getId(), to.hasPermission(Permission.WRITE));
				}
				catch (PermissionDeniedException ex)
				{
					linkTo = any.getToType() + "[id=" + any.getToId() + "] (<i>denied</i>)";
				}
				catch (ItemNotFoundException ex)
				{
					linkTo = any.getToType() + "[id=" + any.getToId() + "] (<i>missing</i>)";
				}
				%>
				<tr>
					<th>Any-to-any link</th>
					<td>
						<table>
						<tr>
							<td><%=Base.getLinkedName(ID, any, false, true) %></td>
							<td><base:icon image="bullet.png" /></td>
							<td><%=linkTo%></td>
						</tr>
						</table>
					</td>
				</tr>
				<%
			}
			else
			{
				%>
				<tr>
					<th><%=node.getNodeType() == Node.Type.FOLDER ? 
							"Folder" : item != null ? item.getType().toString() : "Item"%></th>
					<td>
						<%
						if (item != null)
						{
							%>
							<%=Base.getLink(ID, node.getTitle(), item.getType(),item.getId(), item.hasPermission(Permission.WRITE))%>
							<%
							if (item instanceof Subtypable)
							{
								ItemSubtype subtype = ((Subtypable)item).getItemSubtype();
								if (subtype != null)
								{
									%>
									<span class="itemsubtype">(<%=Base.getLinkedName(ID, subtype, false, true)%>)</span>
									<%
								}
							}
						}
						else
						{
							%>
							<%=HTML.encodeTags(node.getTitle())%>
							<%
						}
						%>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Errors (children)</th>
				<%
				if (showFailures)
				{
				%>
					<td><%=node.getNumErrors()+node.getChildErrors()%> (<%=node.getChildErrors()%>)</td>
				<%
				}
				else
				{				
				%>
					<td><i>- n/a -</i></td>
				<%
				}
				%>
			</tr>
			<tr>
				<th>Warnings (children)</th>
				<%
				if (showFailures)
				{
				%>
					<td><%=node.getNumWarnings()+node.getChildWarnings()%> (<%=node.getChildWarnings()%>)</td>
				<%
				}
				else
				{				
				%>
					<td><i>- n/a -</i></td>
				<%
				}
				%>
			</tr>
			<%
			if (item instanceof Nameable)
			{
				Nameable nameable = (Nameable)item;
				%>
				<tr>
					<th>Description</th>
					<td><%=HTML.niceFormat(nameable.getDescription())%></td>
				</tr>
				<%
			}
			%>
			</table>
			</div>
			
			
			<%
			List<AnnotationSnapshot> annotations = new LinkedList<AnnotationSnapshot>();
			String annotationsTitle = "";
			Annotatable annotatable = null;
			if (item instanceof Annotation)
			{
				Annotation a = Annotation.getById(dc, item.getId());
				AnnotationSetSnapshot snapshot = snapshotManager.getSnapshot(dc, a.getAnnotationSet().getId());
				annotationFilter.setAnnotation(a);
				annotations.addAll(snapshotManager.findAnnotations(dc, snapshot, annotationFilter, true));
				
				// Find the annotatable parent node
				Node parentNode = node;
				while (parentNode != null)
				{
					BasicItem parentItem = parentNode.getItem();
					if (parentItem instanceof Annotatable)
					{
						annotatable = (Annotatable)parentItem;
						break;
					}
					parentNode = parentNode.getParent();
				}
				annotationsTitle = "Annotation values";
			}
			else if (item instanceof AnnotationType)
			{
				// Find the annotatable parent
				Node parentNode = node;
				while (parentNode != null)
				{
					BasicItem parentItem = parentNode.getItem();
					if (parentItem instanceof Annotatable && !(parentItem instanceof Protocol))
					{
						annotatable = (Annotatable)parentItem.getType().getById(dc, parentItem.getId());
						if (annotatable.isAnnotated())
						{
							annotationTypeFilter.setAnnotationType((AnnotationType)item);
							annotations.addAll(snapshotManager.findAnnotations(dc, annotatable, annotationTypeFilter, true));
						}
						annotationsTitle = "Annotation values";
						break;
					}
					parentNode = parentNode.getParent();
				}
			}
			else if (item instanceof Annotatable)
			{
				annotationsTitle = "Annotations &amp; protocol parameters";
				annotatable = (Annotatable)item.getType().getById(dc, item.getId());
				if (annotatable.isAnnotated())
				{
					annotations.addAll(snapshotManager.findAnnotations(dc, annotatable, null, true));
				}
				
			}
			if (annotations != null && annotations.size() > 0)
			{
				%>
				<base:section
					id="allAnnotations"
					title="<%="Annotations &amp; parameters (" +  annotations.size() + ")"%>"
					context="<%=cc %>">
				
				<tbl:table id="annotations">
					<tbl:columndef id="annotation" title="Annotation/parameter" />
					<tbl:columndef id="owner" title="Owner" />
					<tbl:columndef id="values" title="Value" />
					<tbl:columndef id="edit" title="" />
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
							<%
							for (AnnotationSnapshot snapshot : annotations)
							{
								Annotation a = snapshot.getAnnotation(dc);
								String unitSymbol = a.hasUnit() ? "&nbsp;" + a.getUnitSymbol(null) : "";
								AnnotationType at = at = snapshot.getAnnotationType(dc);
								Annotatable annotationOwner = null;
								try
								{
									annotationOwner = snapshot.getItem(dc);
								}
								catch (Throwable t)
								{}
								String icon = at != null && at.isProtocolParameter() ? 
										"parameter.png" : "joust/annotation.gif";
								String editLink = null;
								String editTooltip = null;
								if (annotatable != null && annotatable.hasPermission(Permission.WRITE))
								{
									if (annotatable.equals(annotationOwner))
									{
										editLink = "editAnnotation('" + annotatable.getType().name() + "', " + annotatable.getId() + ", " + at.getId() + ")";
										editTooltip = "Edit the values of this annotation";
									}
									else
									{
										editLink = "editInheritedAnnotation('" + annotatable.getType().name() + "', " + annotatable.getId() + ", " + at.getId() + ")";
										editTooltip = "Inherit this annotation from another item";
									}
								}
								%>
								<tbl:row>
									<tbl:cell column="annotation"><base:icon visible="<%=icon != null%>" image="<%=icon%>" />
										<%=Base.getLinkedName(ID, at, false, true)%>
									</tbl:cell>
									<tbl:cell column="owner">
										<%
										if (annotationOwner != null && !annotationOwner.equals(annotatable))
										{
											String ownerName = annotationOwner instanceof Nameable ?
													((Nameable)annotationOwner).getName() : annotationOwner.toString();
											%>
											<%=Base.getLink(ID, ownerName, annotationOwner.getType(), annotationOwner.getId(), annotationOwner.hasPermission(Permission.WRITE)) %>
											<%
										}
										%>
									</tbl:cell>
									<tbl:cell column="values"><%=Values.getString(a.getValues(null), ", ", true)%><%=unitSymbol%></tbl:cell>
									<tbl:cell column="edit"><base:icon image="edit.png" onclick="<%=editLink%>" 
										tooltip="<%=editTooltip%>" visible="<%=editLink != null %>"/></tbl:cell>
								</tbl:row>
								<%
							}
							%>
						</tbl:rows>
					</tbl:data>				
				</tbl:table>
				</base:section>
				<%
			}			
			if (showFailures)
			{
				%>
				<base:section
					id="failures"
					title="<%="Failure details (" + (node.getNumErrors() + node.getNumWarnings()) + ")"%>"
					context="<%=cc %>"
					>
				<table>
				<%
				int numFailures = 0;
				for (Failure failure : failures)
				{
					Validator validator = failure.getValidator();
					Severity severity = options.getSeverity(validator);
					if (failure.getNode() == node && severity != Severity.IGNORE)
					{
						numFailures++;
						List<Fix> fixes = failure.getFixes();
						%>
						<tr>
							<td><base:icon image="<%=severity == Severity.ERROR ? "error.png" : "warning.png"%>" style="padding-right: 4px;"/></td>
							<td><b><%=HTML.encodeTags(failure.getMessage())%></b></td>
						</tr>
						<tr>
							<td></td>
							<td style="padding-bottom: 0.3em;">
								<%=HTML.encodeTags(validator.getDescription())%><br>
								<%
								if (fixes != null && fixes.size() > 0)
								{
									for (Fix fix : fixes)
									{
										if (fix == null) continue;
										BasicItem fixItem = fix.getItem();
										boolean enabled = fixItem.hasPermission(Permission.WRITE);
										String fixIt = null;
										if (enabled)
										{
											if (fix.isAnnotationFix())
											{
												AnnotationType at = fix.getAnnotationType();
												if (fix.isFromInherited())
												{
													fixIt = "editInheritedAnnotation('" + fixItem.getType().name() + "', " + 
														fixItem.getId() + ", " + at.getId() + ")";
												}
												else
												{
													fixIt = "editAnnotation('" + fixItem.getType().name() + "', " + 
														fixItem.getId() + ", " + at.getId() + ")";
												}
											}
											else if (fix.isDataFileFix())
											{
												FileSetMember member = fix.getFileSetMember();
												fixIt = "editDataFile('" + fixItem.getType().name() + "', " + 
													fixItem.getId() + ")";
											}
											else
											{
												fixIt = "editItem('" + fixItem.getType().name() + "', " + 
													fixItem.getId() + ")";
											}
										}
										%>
										<base:icon image="fixit.png" 
											style="padding-bottom: 4px;" 
											enabled="<%=enabled %>"
										/><% if (enabled)
										{
											%><a href="javascript:<%=fixIt%>" title="Edit this item to fix the problem"
												><%=HTML.encodeTags(fix.getMessage())%></a><br>
											<%
										}
										else
										{
											%><span title="You do not have permission to modify this item" 
												style="color: #999999;"><%=HTML.encodeTags(fix.getMessage())%></a></span><br>
											<%
										}
									}
								}
								%>
							</td>
						</tr>
						<%
					}
				}
				%>
				</table>
				<%
				if (numFailures == 0)
				{
					%>
					<div class="messagecontainer note">
					No validation failures on this item
					</div>
					<%
				}
				%>
				</base:section>
				<%
			}
			%>
			</div>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
