<%-- $Id: duplicate_wizard.jsp 5956 2012-02-13 15:27:40Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is used to catch DuplicateWizardException which are
	directed here via the exception.jsp page. This exception can be
	thrown when a user tries to open more than one plug-in/job configuration
	wizard at the same time.

	@author Nicklas
	@version 2.4
--%>
<%@ page pageEncoding="UTF-8" session="false"
	isErrorPage="true"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld"
%>
<%
Throwable t = exception;
//t is either a JasperException, a ServletException or a WebException; see exception.jsp
if (t instanceof org.apache.jasper.JasperException)
{
	t = ((org.apache.jasper.JasperException)t).getRootCause();
}
if (t instanceof ServletException)
{
	t = ((ServletException)t).getRootCause();
	// t should now be an DuplicateWizardException
}
Throwable ex = t;
%>
<base:page type="popup" menu="exception" title="Another plug-in wizard is active">
<base:head scripts="exception.js">
	<script language="JavaScript">
	function goNext()
	{
		if (confirm('Are you sure? Unsaved settings in the other wizard will be lost.'))
		{
			location.replace(location.href + '&warnIfOpen=0');
		}
	}
	</script>
</base:head>
<base:body onload="Exception.fixWindow(false)">

	<h1>Another plug-in configuration wizard is open</h1>

	<div class="content filled bottomborder">

		<div class="messagecontainer error">
			<b>On page <%=request.getAttribute("javax.servlet.error.request_uri")%></b><br>
			<%=ex.getMessage()%>
		</div>
	</div>

	<base:buttongroup subclass="dialogbuttons">
		<base:button onclick="goNext();" title="Continue" image="gonext.png" />
		<base:button onclick="window.top.close();" title="Cancel" />
	</base:buttongroup>
	
</base:body>
</base:page>

