<%-- $Id: edit_directory.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.DIRECTORY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Directory directory = null;
	Directory parent = null;
	boolean autoCompress = false;
	boolean autoShare = false;

	if (itemId == 0)
	{
		title = "Create directory";
		parent = Directory.getById(dc, Values.getInt(request.getParameter("parent_id"), 
			SystemItems.getId(Directory.ROOT))
		);
		autoCompress = parent.getAutoCompress();
		autoShare = parent.getAutoShare();
		cc.removeObject("item");
	}
	else
	{
		directory = Directory.getById(dc, itemId);
		parent = directory.getParent();
		autoCompress = directory.getAutoCompress();
		autoShare = directory.getAutoShare();
		cc.setObject("item", directory);
		title = "Edit directory -- " + HTML.encodeTags(directory.getName());
	}
	if (directory != null && !directory.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), directory);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Directory" tab
		function validateDirectory()
		{
			var frm = document.forms['directory'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['directory'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (directory == null)
			{
				%>
				var frm = document.forms['directory'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>

		<form action="index.jsp?ID=<%=ID%>" method="post" name="directory" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="parent_id" value="<%=parent.getId()%>">
		
		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=directory != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Directory" validate="validateDirectory()" helpid="directory.edit">
			<table class="fullform input100">
			<tr>
				<th>Path</th>
				<td colspan="2"><%=HTML.encodeTags(parent.getPath().toString())%></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(directory == null ? Values.getString(cc.getPropertyValue("name"), "New directory") : directory.getName())%>" 
					maxlength="<%=Directory.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Compress new files</th>
				<td>
					<input type="radio" name="autoCompress" id="autoCompressNo" value="0" 
						<%=!autoCompress ? "checked" : ""%>><label for="autoCompressNo">no</label>
					<input type="radio" name="autoCompress" id="autoCompressYes" value="1" 
						<%=autoCompress ? "checked" : ""%>><label for="autoCompressYes">yes</label>
					<span title="Select this checkbox to set this property on all subdirectories">
					<input type="checkbox" name="autoCompressRecursive" id="autoCompressRecursive" value="1"
						><label for="autoCompressRecursive">Recursive</label></span>
				</td>
				<td></td>
			</tr>	
			<tr>
				<th>
					Share new files and sub-<br>
					directories automatically
				</th>
				<td>
					<input type="radio" name="autoShare" id="autoShareNo" value="0" 
						<%=!autoShare ? "checked" : ""%>><label for="autoShareNo">no</label>
					<input type="radio" name="autoShare" id="autoShareYes" value="1" 
						<%=autoShare ? "checked" : ""%>><label for="autoShareYes">yes</label>
					<span title="Select this checkbox to set this property on all subdirectories">
					<input type="checkbox" name="autoShareRecursive" id="autoShareRecursive" value="1"
						><label for="autoShareRecursive">Recursive</label></span>
				</td>
				<td></td>
			</tr>	
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="4" name="description" 
						><%=HTML.encodeTags(directory == null ? cc.getPropertyValue("description") : directory.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'directory', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
