<%-- $Id: select.jsp 5946 2012-02-03 13:18:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@page import="net.sf.basedb.core.ItemSubtype"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.zip.FileUnpacker"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	File file = null;
	Directory directory = null;
	boolean readCurrentSubtype = true;
	int currentSubtypeId = 0;
	Boolean compress = Application.autoCompressionEnabled() ? null : false; // null == auto

	if (itemId == 0)
	{
		title = "Upload new file";
		currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), 0);
		if (currentSubtypeId == 0)
		{
			currentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0), 0);
		}
		directory = Directory.getById(dc, Values.getInt(request.getParameter("directory_id"), SystemItems.getId(Directory.ROOT)));
		cc.removeObject("item");
		if (directory.getAutoCompress()) compress = true;
	}
	else
	{
		file = File.getById(dc, itemId);
		file.checkPermission(Permission.WRITE);
		
		directory = file.getDirectory();
		cc.setObject("item", file);
		title = "Upload again -- " + HTML.encodeTags(file.getName());
		try
		{
			ItemSubtype subtype = file.getItemSubtype();
			if (subtype != null) currentSubtypeId = subtype.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
	}
	
	if (file == null || file.getLocation() != Location.PRIMARY)
	{
		// Check quota
		User user = User.getById(dc, sc.getLoggedInUserId());
		QuotaType totalQuotaType = QuotaType.getById(dc, SystemItems.getId(QuotaType.TOTAL));
		QuotaType fileQuotaType = QuotaType.getById(dc, SystemItems.getId(QuotaType.FILE));
		
		if (user.hasExceededQuota(totalQuotaType, Location.PRIMARY) 
			|| user.hasExceededQuota(fileQuotaType, Location.PRIMARY))
		{
			throw new PermissionDeniedException("Quota has been exceeded");
		}
	}
	
	
	// Query to retrieve file types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);
	
	// Query to retreive FileUnpacker plugins
	final ItemQuery<PluginDefinition> pluginQuery = PluginDefinition.getQuery(null, "net.sf.basedb.util.zip.FileUnpacker");
	pluginQuery.order(Orders.asc(Hql.property("name")));
	pluginQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	List<PluginDefinition> plugins = pluginQuery.list(dc);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,ajax.js,json2.js" styles="tabcontrol.css,progressbar.css">
		<script language="JavaScript">
		// Validate the "File" tab
		function validateFile()
		{
			var frm = document.forms['file'];
			if (Main.trimString(frm.the_file.value) == '')
			{
				alert("You must select a file to upload");
				frm.the_file.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function doUpload()
		{
			var frm = document.forms['file'];
			if (TabControl.validateActiveTab('settings'))
			{
				// Copy form values so they are sent BEFORE the file
				frm.check_md5.value = frm.temp_check_md5 && frm.temp_check_md5.checked ? "1" : "0";
				frm.write_protected.value = frm.temp_write_protected.checked ? "1" : "0";
				<%
				if (file == null)
				{
					%>
					frm.replace_existing.value = frm.temp_replace_existing.checked ? "1" : "0";
					<%
				}
				%>
				frm.compressed.value = frm.temp_compressed && frm.temp_compressed[frm.temp_compressed.selectedIndex].value;
				if (frm.temp_zip_format)
				{
					frm.zip_format.value = frm.temp_zip_format[frm.temp_zip_format.selectedIndex].value;
					frm.zip_unpack.value = frm.temp_zip_unpack.checked ? "1" : "0";
					frm.zip_overwrite.value = frm.temp_zip_overwrite.checked ? "1" : "0";
					frm.zip_keep.value = frm.temp_zip_keep.checked ? "1" : "0";
				}
				frm.characterSet.value = frm.temp_charset[frm.temp_charset.selectedIndex].value;
				frm.subtype_id.value = frm.temp_subtype_id[frm.temp_subtype_id.selectedIndex].value;
				frm.description.value = frm.temp_description.value;
				frm.submit();
				Main.hide('selectForm');
				Main.show('progressForm');
				sendProgressUpdateRequest();
			}
		}
		
		function sendProgressUpdateRequest()
		{
			var request = Ajax.getXmlHttpRequest();
			var url = 'ajax.jsp?ID=<%=ID%>&cmd=GetProgress&'+Math.random();
			request.open("GET", url, true);
			Ajax.setReadyStateHandler(request, progressUpdateCallback);
			request.send(null);
		}
		
		function progressUpdateCallback(request)
		{
			var progress = Ajax.parseJsonResponse(request.responseText);
			if (progress && progress.status == 'ok' && progress.file)
			{
				var filename = progress.file;
				var transferredBytes = progress.transferredBytes;
				var totalBytes = progress.totalBytes;
				var timeInSeconds = progress.timeInSeconds;
				var message = progress.message;
				displayProgress(filename, transferredBytes, totalBytes, timeInSeconds, message);
			}
			setTimeout('sendProgressUpdateRequest()', 1500);
		}
		
		function abortUpload()
		{
			if (confirm('Are you sure you want to abort the upload? It cannot be resumed.'))
			{
				var request = Ajax.getXmlHttpRequest();
				var url = 'ajax.jsp?ID=<%=ID%>&cmd=Abort&'+Math.random();
				request.open("GET", url, true);
				request.send(null);
			}
		}
		
		function fileOnChange()
		{
			var frm = document.forms['file'];
			var filename = frm.the_file.value;
			var isZip = false;
			var zipIndex = 0;
			
			for (var i = 0; i < allZipFormats.length; i++)
			{
				var zf = allZipFormats[i];
				if (zf.matchesExtension(filename))
				{
					isZip = true;
					zipIndex = zf.index;
					i = allZipFormats.length;
				}
			}
			
			if (frm.temp_zip_format)
			{
				frm['temp_zip_format'].disabled = !isZip;
				frm['temp_zip_format'].selectedIndex = zipIndex;
				frm['temp_zip_unpack'].disabled = !isZip;
				frm['temp_zip_overwrite'].disabled = !isZip || !frm['temp_zip_unpack'].checked;
				frm['temp_zip_keep'].disabled = !isZip || !frm['temp_zip_unpack'].checked;
				frm['temp_compressed'].disabled = isZip;
				if (isZip)
				{
					// Select '-auto-' if present, otherwise 'no'
					Forms.selectListOption(frm['temp_compressed'], '0');
					Forms.selectListOption(frm['temp_compressed'], '');
				}
			}
		}
		function unpackZipOnClick()
		{
			var frm = document.forms['file'];
			var checked = frm['temp_zip_unpack'].checked;
			if (!checked) frm['temp_zip_keep'].checked = true;
			frm['temp_zip_overwrite'].disabled = !checked;
			frm['temp_zip_keep'].disabled = !checked;
		}
		
		function initZipFormats()
		{
			var frm = document.forms['file'];
			var zipFormat = frm.temp_zip_format;
			if (zipFormat)
			{
			<%
			for (PluginDefinition plugin : plugins)
			{
				FileUnpacker unpacker = plugin.newInstance(FileUnpacker.class, sc, null, null);
				%>
					var extensions = [ '<%=Values.getString(unpacker.getExtensions(), "','", true)%>' ];
					var zf = new ZipFormat(zipFormat.length, <%=plugin.getId()%>, '<%=HTML.javaScriptEncode(unpacker.getFormatName())%>', extensions);
					zipFormat[zipFormat.length] = new Option(zf.toString(), zf.id);
				<%
			}
			%>
			}
		}
		
		function displayProgress(fileName, transferredBytes, totalBytes, transferTime, message)
		{
			// File name
			document.getElementById('fileName').innerHTML = 'Uploading ' + fileName + '...';
				
			// Percent done
			var percentDone = totalBytes == 0 ? 0 : Math.round(100 * transferredBytes / totalBytes);
			document.getElementById('percentText').innerHTML = percentDone+'%';
			var doneElement = document.getElementById('percentDone');
			doneElement.style.width = percentDone+'%';
			var remainElement = document.getElementById('percentRemain');
			remainElement.style.width = (100-percentDone)+'%';
			if (percentDone == 100) Main.hide('percentRemain');
			
			// Bytes
			document.getElementById('transferredBytes').innerHTML = Numbers.formatBytes(transferredBytes);
			document.getElementById('totalBytes').innerHTML = Numbers.formatBytes(totalBytes);

			// Times and rate
			document.getElementById('transferTime').innerHTML = Numbers.formatSeconds(transferTime);
			var transferRate = transferTime == 0 ? 0 : transferredBytes / transferTime;
			document.getElementById('transferRate').innerHTML = '(' + Numbers.formatBytes(transferRate) + '/s)';
			if (transferRate > 0)
			{
				var remainTime = parseInt((totalBytes-transferredBytes) / transferRate);
				document.getElementById('remainTime').innerHTML = Numbers.formatSeconds(remainTime) + ' (estimated)';
			}
			
			// Message
			if (message)
			{
				document.getElementById('message').innerHTML = message.replace(/(.*):(.*)/, '<b>$1:</b> $2');
			}
		}
		
		var allZipFormats = new Array();
		function ZipFormat(index, id, name, extensions)
		{
			this.index = index;
			this.id = id;
			this.name = name;
			this.extensions = extensions;
			
			allZipFormats[allZipFormats.length] = this;
			
			this.matchesExtension = function(filename)
			{
				for (var i = 0; i < this.extensions.length; i++)
				{
					var ext = '.' + this.extensions[i];
					var index = filename.lastIndexOf(ext);
					if (index > 0 && (index + ext.length == filename.length))
					{
						return true;
					}
				}
				return false;
			}
			
			this.toString = function()
			{
				var s = this.name + " [";
				for (var i = 0; i < this.extensions.length; i++)
				{
					if (i > 0) s += ', ';
					s += '*.' + this.extensions[i];
				}
				s += ']';
				return s;
			}
		}
		
		</script>
	</base:head>
	<base:body onload="initZipFormats()">
	<div id="selectForm">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		
		<form action="Upload?ID=<%=ID%>&directory_id=<%=directory.getId()%>" 
			method="post" name="file" enctype="multipart/form-data" onsubmit="return false;" target="upload">

		<input type="hidden" name="check_md5" value="0">
		<input type="hidden" name="write_protected" value="0">
		<input type="hidden" name="replace_existing" value="0">
		<input type="hidden" name="compressed" value="">
		<input type="hidden" name="zip_format" value="">
		<input type="hidden" name="zip_unpack" value="0">
		<input type="hidden" name="zip_overwrite" value="0">
		<input type="hidden" name="zip_keep" value="1">
		<input type="hidden" name="subtype_id" value="">
		<input type="hidden" name="description" value="">
		<input type="hidden" name="characterSet" value="">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol" 
			position="bottom" remember="false">
		<t:tab id="info" title="File" validate="validateFile()" helpid="file.upload">
			<table class="fullform input100">
			<tr>
				<th>Directory</th>
				<td colspan="2"><%=HTML.encodeTags(directory.getPath().toString())%></td>
			</tr>
			<tr>
				<th>File</th>
				<td>
					<input <%=requiredClazz%> type="file" name="the_file"  size="40"
						onchange="fileOnChange()">
				</td>
				<td></td>
			</tr>
			<tr>
				<th></th>
				<td>
					<input type="checkbox" name="temp_write_protected" id="tempWriteProtected" value="1" 
					<%=(file != null && file.isWriteProtected()) || 
						(file == null && Values.getBoolean(cc.getPropertyValue("writeProtected"))) ? "checked" : ""%>>
					<label for="tempWriteProtected">Write protected</label>
					<%
					if (file == null)
					{
						%>
						<input type="checkbox" name="temp_replace_existing" id="tempReplaceExisting" value="1">
						<label for="tempReplaceExisting">Replace existing</label>
						<%
					}
					else
					{
						%>
						<input type="checkbox" name="temp_check_md5" id="tempCheckMd5">
						<label for="tempCheckMd5">Validate MD5</label>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Store compressed</th>
				<td>
					<select name="temp_compressed">
						<%
						if (Application.autoCompressionEnabled())
						{
							%>
							<option value="" <%=compress == null ? "selected" : "" %>>- auto -
							<%
						}
						%>
						<option value="1" <%=Boolean.TRUE.equals(compress) ? "selected" : ""%>>yes
						<option value="0" <%=Boolean.FALSE.equals(compress) ? "selected" : ""%>>no
					</select>
				</td>
				<td></td>
			</tr>
			<tr >
				<th>Type</tdh>
				<td>
					<select name="temp_subtype_id" 
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							boolean current = id == currentSubtypeId;
							%>
							<option 
								value="<%=current && file != null ? -id : id%>" 
								<%=current ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription())%>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Character set</th>
				<td>
					<select name="temp_charset">
					<option value="">- n/a -
					<%
					String currentCharset = file == null ? null : file.getCharacterSet();
					int numCommon = Config.getCommonCharsets().size();
					int i = 0;
					boolean hasSelected = false;
					for (String charset : Config.getAllCharsets())
					{
						boolean selected = false;
						if (!hasSelected)
						{
							selected = charset.equalsIgnoreCase(currentCharset);
							hasSelected |= selected;
						}
						%>
						<option value="<%=charset%>" <%=selected ? "selected" : ""%> 
							<%=i==numCommon ? "style=\"border-top: 1px solid #666666;\"" : "" %>><%=charset%>
						<%
						i++;
					}
					if (!hasSelected && currentCharset != null)
					{
						%>
						<option value="<%=currentCharset%>" selected><%=currentCharset%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<%
			if (file == null)
			{
				%>
				<tr class="big">
					<th>Compressed file</th>
					<td>
						<select name="temp_zip_format" disabled>
							<option>
						</select><br>
					
						<input type="checkbox" name="temp_zip_unpack" id="tempZipUnpack" disabled
							onclick="unpackZipOnClick()"><label for="tempZipUnpack">Unpack file</label><br>
						<input type="checkbox" name="temp_zip_overwrite" id="tempZipOverwrite" disabled
							><label for="tempZipOverwrite">Overwrite existing files</label><br>
						<input type="checkbox" name="temp_zip_keep" id="tempZipKeep" disabled checked
							><label for="tempZipKeep">Keep the compressed file</label><br>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="4" name="temp_description" style="height: 97%;"
						><%=HTML.encodeTags(file == null ? cc.getPropertyValue("description") : file.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'file', 'temp_description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button image="upload.png" onclick="doUpload()" title="Upload" />
			<base:button onclick="top.window.close()" title="Cancel" />
		</base:buttongroup>
	</div>
	
	<div id="progressForm" style="display:none;">
		<h1 class="docked" id="fileName">Preparing file upload...</h1>
		<div class="content">
			<table class="fullcc"><tr><td>
				<table class="progressbar" style="width: 100%;">
				<tr>
					<td style="width: 2em;"></td>
					<td style="">
						<table id="bar" style="width: 100%;">
						<tr>
							<td style="width: 0%;" id="percentDone">&nbsp;</td>
							<td style="width: 100%;" id="percentRemain">&nbsp;</td>
						</tr>
						</table>
					</td>
					<td style="width: 3em;" id="percentText">0%</td>
					<td style="width: 2em;"></td>
				</tr>
				<tr>
					<td></td>
					<td colspan="2" style="text-align: left;">
						<b>Transferred:</b> <span id="transferredBytes">0 bytes</span> of <span id="totalBytes">unknown</span><br>
						<b>Time:</b> <span id="transferTime">0s</span> <span id="transferRate"></span><br>
						<b>Remain:</b> <span id="remainTime">unknown</span><br>
						<span id="message"></span>
					</td>
					<td></td>
				</tr>
				</table>
			</td></tr></table>
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button image="cancel.png" onclick="abortUpload()" title="Abort..." />
		</base:buttongroup>
	
	</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
