<%-- $Id: create_wizard.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http://base.thep.lu.se/
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE.

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.0
--%>



<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.ArrayBatch"	
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final Item itemType = Item.ARRAYSLIDE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{	
	String title = null;
	ArraySlide slide = null;
	String name = "New slides.";
	
	boolean readCurrentArrayBatch = true;
	ArrayBatch currentArrayBatch = null;
	
	// Load recently used items
	List<ArrayBatch> recentArrayBatches = (List<ArrayBatch>)cc.getRecent(dc, Item.ARRAYBATCH);

	title = "Create array slides";
	cc.removeObject("item");
	int arrayBatchId = Values.getInt(request.getParameter("arraybatch_id"));
	if (arrayBatchId != 0)
	{
		currentArrayBatch = ArrayBatch.getById(dc, arrayBatchId);
	}
	else if (cc.getPropertyFilter("arrayBatch.name") != null)
	{
		currentArrayBatch = Base.getFirstMatching(dc, ArrayBatch.getQuery(), "name", cc.getPropertyFilter("arrayBatch.name"));
	}
	if (currentArrayBatch != null)
	{
		name = HTML.encodeTags(currentArrayBatch.getName()) + ".";
	}

	if (slide != null && !slide.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";	
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css,toolbar.css">
		<script language="JavaScript">
		// Validate the "ArraySlide" tab
		function validateArraySlide()
		{
			var frm = document.forms['WizardStep1'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.arraybatch_id && 
				(frm.arraybatch_id.length == 0 || frm.arraybatch_id[frm.arraybatch_id.selectedIndex].value == 0))
			{
				alert("You must select an array batch");
				return false;
			}
			if (Main.trimString(frm.quantity.value) == '')
			{
				alert("You must enter a quantity of slides.");
				frm.quantity.focus();
				return false;
			}
			if (frm.quantity.value < 1)
			{
				alert("The quantity of array slides to be created must be at least 1.")
				frm.quantity.value = 1;
				frm.quantity.select();
				return false;
			}
			else if (frm.quantity.value > 999)
			{
				alert("The quantity of array slides to be created must be lower than 1000.")
				frm.quantity.value = 1;
				frm.quantity.select();
				return false;
			}
			return true;
		}
		
		function validateNames()
		{
			var frm = document.forms['WizardStep2'];
			var quantity = parseInt(frm.quantity.value);
			for (i = 0; i < quantity; i++)
			{
				var name = frm['name'+i];
				if (Main.trimString(name.value) == '')
				{
					name.focus();
					alert('You must enter a name for slide ' + i);
					return false;
				}
			}
			return true;
		}
		
		// Submit the step 1 form and continue to step 2
		function nextStep()
		{			
			if (validateArraySlide())
			{
				var frm = document.forms['WizardStep1'];
				frm.submit();
			}
		}		
		// Submit and finish the wizard
		function saveSettings()
		{
			if (validateNames())
			{
				var frm = document.forms['WizardStep2'];		
				frm.submit();
			}
		}

		function selectArrayBatchOnClick()
		{
			var frm = document.forms['WizardStep1'];
			var url = '../../lims/arraybatches/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setArrayBatchCallback';
			if (frm.arraybatch_id.length > 0) url += '&item_id='+frm.arraybatch_id[0].value;
			Main.openPopup(url, 'SelectArrayBatch', 1050, 700);
		}
		function setArrayBatchCallback(id, name)
		{
			var frm = document.forms['WizardStep1'];
			var list = frm.arraybatch_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		
		function pasteMultiple(prefix)
		{
			Main.openPopup('paste_multiple.jsp?ID=<%=ID%>&form=WizardStep2&prefix=' + prefix, 'PasteMultiple', 400, 600);
		}

		function clearAll(prefix)
		{
			var frm = document.forms['WizardStep2'];
			var i = 0;
			var field;
			while(field = frm[prefix+i])
			{
				field.value = '';
				i++;
			}
		}
		
		function init()
		{					
			var frm = document.forms['WizardStep1'];
			if (frm != null)
			{
				frm.name.focus();
				frm.name.select();
			}
			else
			{
				frm = document.forms['WizardStep2'];
				frm.barcode1.focus();
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<%
		//Wizard step1
		if (cmd.equals("WizardStep1"))
		{
		%>				
			<h1><%=title%> <base:help tabcontrol="settings" /></h1>
			<form action="create_wizard.jsp?ID=<%=ID%>" method="post" name="WizardStep1" onsubmit="return false;">
			<input type="hidden" name="cmd" value="WizardStep2">
			
			<div class="content bottomborder">
				<table class="fullform input100">
				<tr>
					<th>Name</th>
					<td><input <%=requiredClazz%> type="text" name="name"
						value="<%=name%>"
						maxlength="<%=ArraySlide.MAX_NAME_LENGTH%>"></td>
					<td></td>
				</tr>
				<tr>
					<th>Array batch</th>
					<td>
						<base:select 
							id="arraybatch_id"
							clazz="selectionlist required"
							required="true"
							current="<%=currentArrayBatch%>"
							denied="<%=!readCurrentArrayBatch%>"
							recent="<%=recentArrayBatches%>"
							newitem="true"
							onselect="selectArrayBatchOnClick()"
						/>
					</td>
					<td></td>
				</tr>
				<tr>
					<th>Quantity</th>
					<td><input <%=requiredClazz%> type="text" name="quantity" value="50" 
						 maxlength="3" style="width: 5em;"
						onkeypress="return Numbers.integerOnly(event)"><i> (1-999)</i></td>
					<td></td>
				</tr>
				<tr>
					<th>Start at</th>
					<td><input <%=clazz%> type="text" name="start_at" value="1" 
						maxlength="10" style="width: 10em;"
						onkeypress="return Numbers.integerOnly(event)">
					</td>
					<td></td>
				</tr>
				<tr>
					<th class="subprompt">- pad size</th>
					<td>
						<input <%=clazz%> type="text" name="pad_length" value="" 
						maxlength="1" style="width: 10em;"
						onkeypress="return Numbers.integerOnly(event)">
					</td>
					<td>
				</tr>
				<tr>
					<th class="subprompt"></th>
					<td>
						<div class="messagecontainer help">
						The index number will be padded with zeroes to this length 
						(ie, 1 --&gt; Slide.001; 10 --&gt; Slide.010). Leave empty 
						for automatic selection. 
						</div>
					</td>
					<td></td>
				</tr>
				<tr class="dynamic">
					<th>Description</th>
					<td>
						<textarea <%=clazz%> rows="6" name="description" 
							><%=HTML.encodeTags(cc.getPropertyValue("description"))%></textarea>
					</td>
					<td style="width: 20px;">
						<base:icon image="zoom.png" 
							onclick="Main.zoom('Description', 'WizardStep1', 'description')"
							tooltip="Edit in larger window"
						/>
					</td>
				</tr>
				</table>
				</div>
			</form>
		<%
		}
		//Wizard step 2
		else if (cmd.equals("WizardStep2"))
		{
			name = Values.getStringOrNull(request.getParameter("name"));
			String description = Values.getString(request.getParameter("description"), "");
			arrayBatchId = Values.getInt(request.getParameter("arraybatch_id"));
			int quantity = Values.getInt(request.getParameter("quantity"));
			int startAt = Values.getInt(request.getParameter("start_at"), 1);
			%>	
			<h1><%=title%> <base:help tabcontrol="settings" /></h1>
			<form action="index.jsp?ID=<%=ID%>" method="post" name="WizardStep2" onsubmit="return false;">				
			<input type="hidden" name="cmd" value="CreateItems">
			<input type="hidden" name="description" value="<%=HTML.encodeTags(description)%>">
			<input type="hidden" name="arraybatch_id" value="<%=arrayBatchId%>">
			<input type="hidden" name="quantity" value="<%=quantity%>">
			<input type="hidden" name="start_at" value="<%=startAt%>">
			
			<div class="content bottomborder">

				<table class="fullform input100">
					<colgroup>
						<col style="max-width: 5em;">
						<col span="2" style="width: 47%;">
					</colgroup>
					<tbody class="sectionheader">
					<tr>
						<th>&nbsp;</th>
						<th>Name: 
							<base:icon image="paste.png" onclick="pasteMultiple('name')" 
								tooltip="Paste multiple values in a single large textarea" />
							<base:icon image="clear_down.png" onclick="clearAll('name')" 
								tooltip="Clear all values" />
						</th>
						<th>Barcode:
							<base:icon image="paste.png" onclick="pasteMultiple('barcode')" 
								tooltip="Paste multiple values in a single large textarea" />
							<base:icon image="clear_down.png" onclick="clearAll('barcode')" 
								tooltip="Clear all values" />
						</th>
					</tr>
					</tbody>
					<tbody>
					<%
					int padLength = Values.getInt(request.getParameter("pad_length"));
					if (padLength == 0)
					{
						int lastIndex = startAt + quantity - 1;
						padLength = (int)Math.log10(lastIndex) + 1;
					}
					for (int i = 0; i < quantity; i++)
					{
						int index = startAt + i;
						String paddedName = name + net.sf.basedb.util.MD5.leftPad(String.valueOf(index), '0', padLength);
						%>
						<tr>
							<th><%=index%></th>
							<td><input type="text" <%=requiredClazz%> name="name<%=i%>" 
								value="<%=paddedName%>" size="40" maxlength="<%=ArraySlide.MAX_NAME_LENGTH%>"></td>
							<td><input <%=clazz%> type="text" name="barcode<%=i%>"  
								size="40" maxlength="<%=ArraySlide.MAX_BARCODE_LENGTH%>">
							</td>							
						</tr>
						<%
					}
					%>
					<tr class="dynamic">
						<th></th>
						<td></td>
						<td></td>
					</tr>
					</tbody>
				</table>
				</div>
			</form>
			
		<%
		}
		%>		
		<div class="legend" style="height: 2em;">
			<base:icon image="required.png" />= required information
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings();" title="Save" visible="<%=cmd.equals("WizardStep2")%>" />
			<base:button onclick="nextStep();" title="Next" image="gonext.png" visible="<%=cmd.equals("WizardStep1")%>" />
			<base:button onclick="window.close();" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>
