<%-- $Id: list_reporters.jsp 5966 2012-02-16 08:27:56Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.VirtualDb"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.DynamicReporterQuery"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.DynamicResultIterator"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Selects"
	import="net.sf.basedb.core.query.Dynamic"
	import="net.sf.basedb.core.query.SqlResult"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ColorGenerator"
	import="net.sf.basedb.util.formatter.LookupFormatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.ArrayList"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.REPORTER;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int experimentId = Values.getInt(request.getParameter("experiment_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("spot data", "spot data");
final DbControl dc = sc.newDbControl();
DynamicResultIterator reporters = null;
try
{
	final Experiment experiment = Experiment.getById(dc, experimentId);
	final String subContext = "clonedreporters." + experimentId;
	final boolean writePermission = experiment.hasPermission(Permission.WRITE);
	VirtualDb virtualDb = experiment.getVirtualDb();
	if (!virtualDb.hasClonedReporters()) 
	{
		response.sendRedirect("../index.jsp?ID="+ID + "&cmd=ViewItem&item_id="+experimentId);
		return;
	}

	final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	
	List<TableColumn> columns = new LinkedList<TableColumn>();
	DynamicUtil.addReporterColumns(columns, dc, experiment.getVirtualDb().getReporterCloneTemplate(), "cln.", "@", "[Cln] ");
	DynamicUtil.addReporterColumns(columns, dc, "mst.", "@@", "[Mst] ");
	DynamicUtil.SelectedInfo selected = DynamicUtil.getSelectedColumns(cc, columns, false);
	final boolean hasUpToDateColumn = true;
	try
	{
		final DynamicReporterQuery query = Reporter.getDynamicQuery(experiment);
		query.select(Selects.expression(Dynamic.reporter("id"), "id", true));
		if (hasUpToDateColumn)
		{
			query.select(
				Selects.expression(
					Expressions.bool(Restrictions.eq(Dynamic.reporter("version", true), Dynamic.reporter("version", false))),
					"upToDate"
				));
		}
		cc.configureQuery(dc, query, selected.selectedProperties);
		query.setFailSafe(true);
		reporters = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'reporters';
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, 'DEFAULT', viewItem, editItem, null);
		}		
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 750, 500);
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties' || tabId == 'overview' || tabId == 'history' || tabId == 'annotations')
			{
				location.href = '../index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=experimentId%>&tab='+tabId;
			}
			else if (tabId == 'bioassaysets')
			{
				viewBioAssaySets();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function viewBioAssaySets()
		{
			location.href = '../bioassaysets/index.jsp?ID=<%=ID%>&experiment_id=<%=experimentId%>';
		}
		function newReporterList()
		{
			Table.submitToPopup(formId, 'CreateReporterList', 600, 400);
		}
		function removeClonedReporters()
		{
			if (confirm('Are you sure that you want to remove all cloned reporter annotations?\nThis action can\'t be undone.'))
			{
				Main.openPopup('../index.jsp?ID=<%=ID%>&cmd=RemoveClonedReporters&item_id=<%=experimentId%>', 'RemoveClonedReporters', 450, 300);
			}
		}
		function updateClonedReporters()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=UpdateClonedReporters&experiment_id=<%=experimentId%>', 'UpdateClonedReporters', 600, 400);
		}
		</script>
	</base:head>
	<base:body>
		<p:path><p:pathelement
			title="Experiments" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
			/></p:path>

		<t:tabcontrol 
			id="main" 
			subclass="mastertabcontrol content"
			active="clonedreporters" switch="switchTab">
		<t:tab id="properties" title="Properties" />
		<t:tab id="annotations" title="Annotations" 
			tooltip="View annotation values" />
		<t:tab id="bioassaysets" title="Bioassay sets" />

		<t:tab id="clonedreporters" title="Cloned reporters" >
		<tbl:table 
			id="reporters" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="experiment_id" 
				value="<%=String.valueOf(experimentId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<%
			for (TableColumn tc : columns)
			{
				%>
				<tbl:columndef
					id="<%=tc.getId()%>"
					property="<%=tc.getProperty()%>"
					tooltip="<%=tc.getDescription()%>"
					datatype="<%=tc.getDatatype().getStringValue()%>"
					title="<%=HTML.encodeTags(tc.getTitle())%>"
					sortable="<%=tc.getSortable()%>"
					filterable="<%=tc.getFilterable()%>"
					exportable="<%=tc.getExportable()%>"
					show="<%="cln.externalId".equals(tc.getId()) ? "always" : tc.getShow()%>"
					formatter="<%=tc.getFormatter()%>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="upToDate"
				property="upToDate"
				filterproperty="=rep('version') == mrep('version')"
				exportproperty="=rep('version') == mrep('version')"
				datatype="boolean"
				title="Up to date"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="reporterList"
				property="£reporterList"
				datatype="int"
				title="Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						image="columns.png" 
						onclick="configureColumns()" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						image="add.png"
						onclick="newReporterList()"
						title="New reporter list&hellip;"
						tooltip="Create a new reporter list from matching spots"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
					/>
					<tbl:button
						visible="<%=writePermission%>"
						image="refresh.png"
						onclick="updateClonedReporters()"
						title="Update cloned reporters&hellip;"
						tooltip="Update all cloned reporter annotations with information from the master table"
					/>
					<tbl:button
						visible="<%=writePermission%>"
						image="delete_permanently.png"
						onclick="removeClonedReporters()"
						title="Remove cloned reporters&hellip;"
						tooltip="Remove all cloned reporter annotations"
					/>
					<tbl:button 
						image="export.png" 
						onclick="runPlugin('ExportItems')" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						onchange="presetOnChange()"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=reporters == null ? 0 : reporters.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header 
							clazz="index"
							colspan="2"
						/>
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header 
							clazz="index"
							colspan="2"
						/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (reporters != null)
					{
						while (reporters.hasNext())
						{
							SqlResult item = reporters.next();
							int itemId = item.getInt(1);
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
									<tbl:cell column="upToDate" visible="<%=hasUpToDateColumn %>">
										<%=item.getObject(2) %>
									</tbl:cell>
								<%
								int colIndex = hasUpToDateColumn ? 3 : 2;
								for (String columnId : selected.selectedIds)
								{
									if ("cln.externalId".equals(columnId))
									{
										%>
										<tbl:cell column="cln.externalId"><div class="link" onclick="itemOnClick(event, <%=itemId%>)" 
											title="View this item (use CTRL, ALT or SHIFT to edit)"><%=HTML.encodeTags(item.getString(colIndex))%></div></tbl:cell>
										<%
									}
									else
									{
										%>
										<tbl:cell column="<%=columnId%>" value="<%=item.getObject(colIndex)%>" />
										<%
									}
									++colIndex;
								}
								%>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
							<%=reporters == null || reporters.getTotalCount() == 0 ? "No reporters were found" : "No reporters on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
		</tbl:table>
		</t:tab>

		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items" />
		<t:tab id="history" title="Change history" 
			tooltip="Displays a log of all modifications made to this item"
			visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>" />
		</t:tabcontrol>

		<base:buttongroup>
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
