<%-- $Id: view_rawdata.jsp 5952 2012-02-10 12:27:27Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.Feature"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.ArrayDesignBlock"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.data.RawData"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.data.FeatureData"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
	private static final Item itemType = Item.RAWDATA;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final int rawBioAssayId = Values.getInt(request.getParameter("rawbioassay_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	final RawBioAssay rawBioAssay = RawBioAssay.getById(dc, rawBioAssayId);
	final RawDataType rawDataType = rawBioAssay.getRawDataType();
	final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, rawDataType.getId(), null, null);
	final int itemId = cc.getId();
	final boolean hasSpotImages = rawBioAssay.hasSpotImages();	
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	final RawData rawData = rawBioAssay.getRawDataById(itemId, true);
	String title = "Raw data of "+HTML.encodeTags(rawBioAssay.getName()) + " at position " + rawData.getPosition();
	
	final ReporterData reporter = rawData.getReporter();
	final FeatureData feature = rawData.getFeature();
	Formatter<Date> dateFormatter = FormatterFactory.getDateTimeFormatter(sc);
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	%>
	<base:page title="<%=title%>" type="popup">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
	</base:head>
	<base:body>
		<h1><%=title%></h3>
	
		<t:tabcontrol id="rawdata" 
			subclass="content dialogtabcontrol"
			position="bottom">
		<t:tab id="raw" title="Raw data">
		
			<table class="fullform outlined larger">
			<tbody class="sectionheader">
				<tr>
					<th colspan="4">Common rawdata properties</th>
				</tr>
			</tbody>
			<tbody>
			<tr>
				<th>Position</th>
				<td><%=rawData.getPosition()%></td>
				<th class="leftborder">Block</th>
				<td><%=rawData.getBlock()%></td>
			</tr>
			<tr>
				<th>Row</th>
				<td><%=rawData.getRow()%></td>
				<th class="leftborder">Column</th>
				<td><%=rawData.getColumn()%></td>
			</tr>
			<tr>
				<th>Meta grid X</th>
				<td><%=rawData.getMetaGridX()%></td>
				<th class="leftborder">Meta grid Y</th>
				<td><%=rawData.getMetaGridY()%></td>
			</tr>
			<tr>
				<th>X</th>
				<td><%=rawData.getX()%></td>
				<th class="leftborder">Y</th>
				<td><%=rawData.getY()%></td>
			</tr>
			<tr>
				<th>Reporter</th>
				<td><%=reporter == null ? "<i>- none -</i>" : HTML.encodeTags(reporter.getName())%></td>
				<th class="leftborder">Feature</th>
				<td><%=feature == null ? "<i>- none -</i>" : feature.getId()%></td>
			</tr>
			<tr>
				<th>Spot image</t>
				<td>
					<%
					if (hasSpotImages)
					{
						%>
						<img class="spotimage" src="spotimage/<%=ID%>/<%=rawBioAssay.getId()%>/<%=itemId%>/spot<%=rawData.getPosition()%>.png">
						<%
					}
					else
					{
						%>
						<i>- none -</i>
						<%
					}
					%>
				</td>
				<th class="leftborder"></th>
				<td></td>
			</tr>
			</tbody>
			
			<tbody class="sectionheader">
				<tr>
					<th colspan="4"><%=rawDataType.getName()%> properties</th>
				</tr>
			</tbody>
			
			<tbody>
					<%
					boolean needsTr = true;
					for (RawDataProperty rawProperty : rawDataType.getProperties())
					{
						String name = rawProperty.getName();
						Formatter f = FormatterFactory.getExtendedPropertyFormatter(sc, rawProperty);
						String value = f.format(rawData.getExtended(name));
						title = Values.trimString(rawProperty.getTitle(), 25);
						%>
							<%=needsTr ? "<tr><th>" : "<th class=\"leftborder\"" %>
							<span 
								title="<%=HTML.encodeTags(rawProperty.getDescription())%>"><%=HTML.encodeTags(title)%></span>
							</th>
							<td><%=value%></td>
							<%=needsTr ? "" : "</tr>"%>
						<%
						needsTr = !needsTr;
					}
					%>
					<%=needsTr ? "" : "<th class=\"leftborder\"></th><td></td></tr>"%>
				<tr class="dynamic">
					<th></th>
					<td></td>
					<th class="leftborder"></th>
					<td></td>
				</tr>
			</tbody>			
			</table>
		
		</t:tab>
		
		<%
		if (reporter != null)
		{
			boolean readCurrentReporterType = true;
			ReporterType currentReporterType = null;
			try
			{
				currentReporterType = Reporter.getReporterType(dc, reporter);
			}
			catch (PermissionDeniedException ex)
			{
				readCurrentReporterType = false;
			}
			%>
			<t:tab id="reporter" title="Reporter" >
				<table class="fullform outlined">
				<tbody class="sectionheader">
					<tr>
						<th colspan="4">Common reporter properties</th>
					</tr>
				</tbody>
				<tbody>
				
				<tr>
					<th>Name</th>
					<td><%=HTML.encodeTags(reporter.getName())%></td>
					<th class="leftborder">External ID</th>
					<td><%=HTML.encodeTags(reporter.getExternalId())%></td>
				</tr>
				<tr>
					<th>Gene symbol</td>
					<td><%=HTML.encodeTags(reporter.getSymbol())%></td>
					<th class="leftborder">Type</th>
					<td><%=Base.getEncodedName(currentReporterType, !readCurrentReporterType)%></td>
				</tr>
				<tr>
					<th>Last update</th>
					<td><%=dateFormatter.format(reporter.getLastUpdate())%></td>
					<th class="leftborder">from/by</th>
					<td><%=reporter.getLastSource() %></td>
				</tr>
				<tr>
					<th>Description</th>
					<td colspan="3"><%=HTML.niceFormat(reporter.getDescription())%></td>
				</tr>
				</tbody>
				
				<tbody class="sectionheader">
					<tr>
						<th colspan="4">Extended reporter properties</th>
					</tr>
				</tbody>
				<tbody>
						<%
						List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
						if (reporterProperties != null)
						{
							boolean needsTr = true;
							for (ExtendedProperty ep : reporterProperties)
							{
								String name = ep.getName();
								Formatter f = FormatterFactory.getExtendedPropertyFormatter(sc, ep);
								String value = f.format(reporter.getExtended(name));
								%>
									<%=needsTr ? "<tr><th>" : "<th class=\"leftborder\">" %>
									<%=HTML.encodeTags(ep.getTitle())%></th>
									<td><%=value%></td>
									<%=needsTr ? "" : "</tr>"%>
								<%
								needsTr = !needsTr;
							}
							%>
							<%=needsTr ? "" : "<th class=\"leftborder\"></th><td></td></tr>"%>
							<%
						}
						%>
					<tr class="dynamic">
						<th></th>
						<td></td>
						<th class="leftborder"></th>
						<td></td>
					</tr>
				</tbody>
				</table>
			</t:tab>
			<%
		}
		%>
		<%
		if (feature != null)
		{
			ArrayDesignBlock block = null;
			boolean readBlock = true;
			try
			{
				block = Feature.getArrayDesignBlock(dc, feature);
			}
			catch (PermissionDeniedException ex)
			{
				readBlock = false;
			}
			
			Well well = null;
			boolean readWell = true;
			try
			{
				well = Feature.getWell(dc, feature);
			}
			catch (PermissionDeniedException ex)
			{
				readWell = false;
			}
			%>
			<t:tab id="feature" title="Feature / well" >
			<table class="fullform outlined">
				<tbody class="sectionheader">
					<tr>
						<th colspan="6">Feature</th>
					</tr>
				</tbody>
				<tbody>
					<tr>
						<th>Position</td>
						<td><%=feature.getPosition()%></td>
						<th class="leftborder">Meta grid X</td>
						<td><%=readBlock ? Integer.toString(block.getMetaGridX()) : "<i>- denied -</i>"%></td>
						<th class="leftborder">Meta grid Y</th>
						<td><%=readBlock ? Integer.toString(block.getMetaGridY()) : "<i>- denied -</i>"%></td>
					</tr>
					<tr>
						<th>Feature ID</th>
						<td><%=feature.getExternalId() %></td>
						<th class="leftborder">Block size X</th>
						<td><%=readBlock ? Integer.toString(block.getBlockSizeX()) : "<i>- denied -</i>"%></td>
						<th class="leftborder">Block size Y</th>
						<td><%=readBlock ? Integer.toString(block.getBlockSizeY()) : "<i>- denied -</i>"%></td>
					</tr>
					<tr>
						<th>Block number</th>
						<td><%=block.getBlockNumber()%></td>
						<th class="leftborder">Origin X</th>
						<td><%=readBlock ? Integer.toString(block.getOriginX()) : "<i>- denied -</i>"%></td>
						<th class="leftborder">Origin Y</th>
						<td><%=readBlock ? Integer.toString(block.getOriginY()) : "<i>- denied -</i>"%></td>
					</tr>
					<tr>
						<th>Row</th>
						<td><%=feature.getRow()%></td>
						<th class="leftborder">Spacing X</th>
						<td><%=readBlock ? Integer.toString(block.getSpacingX()) : "<i>- denied -</i>"%></td>
						<th class="leftborder">Spacing Y</th>
						<td><%=readBlock ? Integer.toString(block.getSpacingY()) : "<i>- denied -</i>"%></td>
					</tr>
					<tr>
						<th>Column</th>
						<td><%=feature.getColumn()%></td>
						<th class="leftborder"></th>
						<td></td>
						<th class="leftborder"></th>
						<td></td>
					</tr>
				</tbody>
				
				<tbody class="sectionheader">
					<tr>
						<th colspan="6">Plate position</th>
					</tr>
				</tbody>
				
				<tbody>
					<%
					if (!readWell)
					{
						%>
						<tr>
							<th>Plate</th>
							<td colspan="5"><i>- denied -</i></td>
						</tr>
						<%
					}
					else if (well == null)
					{
						%>
						<tr>
							<th>Plate</th>
							<td colspan="5"><i>- none -</i></td>
						</tr>
						<%
					}
					else
					{
						Plate plate = well.getPlate();
						%>
						<tr>
							<th>Plate</th>
							<td colspan="5"><%=HTML.encodeTags(plate.getName())%></td>
						</tr>
						<tr>
							<th>Well</th>
							<td colspan="5"><%=rowFormatter.format(well.getRow())%><%=columnFormatter.format(well.getColumn())%></td>
						</tr>
						<%
					}
					%>
					<tr class="dynamic">
						<th></th>
						<td colspan="5"></td>
					</tr>
				</tbody>
			</table>
			</t:tab>
			<%
		}
		%>
		</t:tabcontrol>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="window.close()" title="Close" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
