<%-- $Id: view_session.jsp 5915 2011-12-16 12:50:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Session"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final Item itemType = Item.SESSION;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Session s = Session.getById(dc, itemId);
	
	boolean readUser = true;
	User user = null;
	try
	{
		user = s.getUser();
	}
	catch (Exception ex)
	{
		readUser = false;
	}
	boolean readClient = true;
	Client client = null;
	try
	{
		client = s.getClient();
	}
	catch (Exception ex)
	{
		readClient = false;
	}
	
	String title = "View session";
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head>
	</base:head>
	<base:body>
		
		<h1><%=title%> <base:help helpid="session.view" /></h1>
		<div class="content">
			<table class="fullform bottomborder outlined">
			<tr>
				<th>User</th>
				<td><%=Base.getEncodedName(user, readUser)%></td>
			</tr>
			<tr>
				<th>Client application</th>
				<td><%=Base.getEncodedName(client, !readClient)%></td>
			</tr>
			<tr>
				<th>Login time</th>
				<td><%=dateTimeFormatter.format(s.getLoginTime())%></td>
			</tr>
			<tr>
				<th>Logout time</th>
				<td><%=dateTimeFormatter.format(s.getLogoutTime())%></td>
			</tr>
			<tr>
				<th>Remote ID</th>
				<td><%=HTML.encodeTags(s.getRemoteId())%></td>
			</tr>
			<tr>
				<th>Impersonated</th>
				<td><%=s.getImpersonated()%></td>
			</tr>
			<tr class="dynamic">
				<th>Comment</th>
				<td><%=HTML.niceFormat(s.getLoginComment())%></td>
			</tr>
			</table>
		</div>
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="window.close()" title="Close" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.commit();
}

%>
